/******************************************/
/* examples program for ET-LAB3A          */
/* description : scan dot matrix led      */
/* compiler    : hi-tech c51              */
/******************************************/

/*  include section */
#include <8051.h>

/*  define  section  */
#define CLK    P1_BITS.B7
#define ENA    P1_BITS.B4
#define RST    P1_BITS.B6

#define SER    P1_BITS.B5
#define SRCLK  P1_BITS.B1
#define SRCLR  P1_BITS.B0
#define RCK    P1_BITS.B2
#define G      P1_BITS.B3

/*  pototype  section */
void dataout(void);
void outword(unsigned int);
void out595(unsigned char);
void delay(unsigned char);

/*******************************************/
/*            main  program                */
/*******************************************/
void main(void)
{
  G  = 0;
  SRCLR = 1;
  RST = 1;
  ENA = 0;

  delay(20);
 
  while(1)
  {
    dataout();
  }    
}


/***********************************************/
/*                  send data                  */
/***********************************************/
void dataout(void)
{
 char j;
  
  RST = 1;
  RST = 0;

  for(j = 0;j < 7;j++)
  {
    outword(0xFFFF);    
    CLK = 1;            delay(10);  
    CLK = 0;            delay(10); 
    outword(0x0000);
    delay(250);
  }
    outword(0xFFFF);

 return;
}


void outword(unsigned int i)
{
  out595(i);
  out595(i >> 8);

  RCK = 1;       delay(10);
  RCK = 0;       delay(10);
  G = 0;         delay(10);
}


void out595(unsigned char i)
{
 char j;
 
 for(j=0;j<8;j++)
 {
   if((i & 0x80) == 0x80) {SER = 1;}
   else                   {SER = 0;}

   SRCLK = 1;      delay(10);
   SRCLK = 0;      delay(10);
   i <<= 1;
 }

 return;
}


void delay(unsigned char i)
{

 do{}while(i-- > 0);

 return;
}
